* Test file for testing op-codes
* Written and constantly being updated by Paul Clarke (1/22/98)

ROTATER         EQU     $C000

		ORG 0
		LDS  #$1FF              ; Load stack pointer
		LDAA #0                 ; Initialize ACCA to 0
		LDAB #1                 ; Initialize ACCB to 1
		STAB ROTATER            ; Initialize ROTATER to 1
		STAB $1004              ; Initialize PORTB to 1
		LDX  #1                 ; Initialize IX to 1

*                CLI                     ; Enable interrupts

LOOP:           
* Allow a total of 8 subroutines to be called

		CMPA    #1
		BEQ     JSUB1
		CMPA    #2
		BEQ     JSUB2
		CMPA    #3
		BEQ     JSUB3
		CMPA    #4
		BEQ     JSUB4
		CMPA    #5
		BEQ     JSUB5
		CMPA    #6
		BEQ     JSUB6
		CMPA    #7
		BEQ     JSUB7
		CMPA    #8
		BEQ     JSUB8
		
		BRA     END            ; Just loop if no subroutine
					; is selected
JSUB1:          JSR     SUB1                
		BRA     END
JSUB2:          JSR     SUB2
		BRA     END
JSUB3:          JSR     SUB3
		BRA     END
JSUB4:          JSR     SUB4
		BRA     END
JSUB5:          JSR     SUB5
		BRA     END
JSUB6:          JSR     SUB6
		BRA     END
JSUB7:          JSR     SUB7
		BRA     END
JSUB8:          JSR     SUB8

END:            BRA     LOOP


SUB1:           
				


SUB2:           CMPB #0
		BNE ROT2
		SEC     ; Set carry if ACCB is zero
ROT2:           RORB    ; Rotate ACCB
		STAB $1003      ; Show in Port C
		RTS

SUB3:           PSHA
		LDAA ROTATER
		CMPA #0
		BNE ROT3
		SEC
ROT3:           ROR ROTATER     ; Rotate memory (EXT)
		PULA
		RTS

SUB4:           PSHX
		PSHA
		LDAA ROTATER
		CMPA #0
		BNE ROT4
		SEC
ROT4:           LDX #ROTATER
		ROR 0,X         ; Rotate memory (IND X)
		PULA
		PULX
		RTS

SUB5:           PSHY
		PSHA
		LDAA ROTATER
		CMPA #0
		BNE ROT5
		SEC
ROT5:           LDY #ROTATER
		ROR 0,Y         ; Rotater memory (IND Y)
		PULA
		PULY
		RTS

SUB6:           PSHA
		LDAA $1004      ; Use Port B
		CMPA #0
		BNE ROT6
		SEC
ROT6:           RORA            ; Rotate ACCA
		STAA $1004      ; Show in Port B
		PULA
		RTS

SUB7:           RTS

SUB8:           RTS

