#if !defined(AFX_HC11VIEW_H__6DC37118_53BB_11D1_A2C3_0000C0E665E5__INCLUDED_)
#define AFX_HC11VIEW_H__6DC37118_53BB_11D1_A2C3_0000C0E665E5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// Hc11View.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CHc11View form view

//////////////////////////////////////////////////////////////////////////////
//
// Class Name: CHc11View
//
// Author: Kalle Anderson & Matt Enwald
//
// Purpose: The main view of the GUI, that contains all the buttons and stuff.
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

#include "PortConnectionDlg.h"
#include "PortIO.h"
#include "MemoryWatch.h"
#include "MCUDlg.h"
#include "PinGraph.h"
#include "7SegDlg.h"
#include "MemoryBrowseDlg.h"
#include "CodeViewerDlg.h"

#define WM_THREAD_STOP (WM_USER + 1)

class CHc11View : public CFormView
{
protected:
	CHc11View();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CHc11View)

// Form Data
public:
	//{{AFX_DATA(CHc11View)
	enum { IDD = IDD_MAINDIALOG };
	CEdit	m_bpctrl;
	CButton	m_stepctrl;
	CButton	m_runctrl;
	CButton	m_xirqctrl;
	CButton	m_irqctrl;
	CBitmapButton	m_cpubutton;
	CString	m_breakp;
	//}}AFX_DATA

// Attributes
public:

// Operations
public:
    // These are all the pop-up windows associated with the buttons in this view
    CPortIO *m_pADlg;
	CPortIO *m_pBDlg;
	CPortIO *m_pCDlg;
	CPortIO *m_pDDlg;
	CPortIO *m_pEDlg;
    CMemoryWatch *m_pWatch;
    CRegisterWatch *m_pRegWatch;
    CMCUDlg *m_pMCUDlg;
    CPinGraph *m_pGraphDlg;
    C7SegDlg *m_p7seg;
	CMemoryBrowseDlg *m_pMemBrowse;
	CCodeViewerDlg *m_pCodeView;
    
    // bitmaps for some buttons in this view
    CBitmap stepbmp;
    CBitmap runningbmp;
    CBitmap stoppedbmp;
        
    // called to update some of the pop-up windows
    void Update(void);
    
    // Function to recieve the WM_THREAD_STOP message from the worker thread.
    LRESULT OnThreadStop(WPARAM, LPARAM);


    // Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHc11View)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CHc11View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CHc11View)
	afx_msg void OnMemoryClick();
	afx_msg void OnCpuClick();
	afx_msg void OnPortAClick();
	afx_msg void OnPortBClick();
	afx_msg void OnPortCClick();
	afx_msg void OnPortDClick();
	afx_msg void OnPortEClick();
	afx_msg void OnMemoryWatch();
	afx_msg void OnRegs();
	afx_msg void OnIrq();
	afx_msg void OnXirq();
	afx_msg void OnReset();
	afx_msg void OnRun();
	afx_msg void OnStep();
	afx_msg void OnKillfocusTestedit();
	afx_msg void OnChangeBpedit();
	afx_msg void OnGraphtest();
	afx_msg void OnGo7seg();
	afx_msg void OnViewCode();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HC11VIEW_H__6DC37118_53BB_11D1_A2C3_0000C0E665E5__INCLUDED_)
