#if !defined(AFX_PORTIO_H__64155C04_8F7A_11D1_BF13_0000C0E665E5__INCLUDED_)
#define AFX_PORTIO_H__64155C04_8F7A_11D1_BF13_0000C0E665E5__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// PortIO.h : header file
//
#include "../emu/hc11io.h"


//////////////////////////////////////////////////////////////////////////////
//
// Class Name: CPortIO
//
// Author: Kalle Anderson
//
// Purpose: This is the blinky led view for the ports. Also, if you click on 
//          an led, it will try to change that pins state.
//
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
// CPortIO dialog
class CPortIO : public CDialog, public PortConnection
{
// Construction
    void Update(byte_t val);
public:
	CPortIO(PortRegister *port, CString title, CWnd* pParent = NULL);   // standard constructor   
	// from PortConnection
    void Write(byte_t);
    void Visible(bool val);    

// Dialog Data
	//{{AFX_DATA(CPortIO)
	enum { IDD = IDD_PORTIO };
	CButton	m_active;
	CEdit	m_valuec;
	CButton	m_pin7c;
	CButton	m_pin6c;
	CButton	m_pin4c;
	CButton	m_pin5c;
	CButton	m_pin3c;
	CButton	m_pin2c;
	CButton	m_pin1c;
	CButton	m_pin0c;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPortIO)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	PortRegister * m_port;
    CBitmap led_on;
    CBitmap led_off;

	// Generated message map functions
	//{{AFX_MSG(CPortIO)
	virtual BOOL OnInitDialog();
	afx_msg void OnPin0();
	afx_msg void OnPin1();
	afx_msg void OnPin2();
	afx_msg void OnPin3();
	afx_msg void OnPin4();
	afx_msg void OnPin5();
	afx_msg void OnPin6();
	afx_msg void OnPin7();
	virtual void OnOK();
	afx_msg void OnActive();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PORTIO_H__64155C04_8F7A_11D1_BF13_0000C0E665E5__INCLUDED_)
